package com.inca.npbusi.sales.bms_sales_back;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.sales.bms_tr_fetch.tickhov.Bms_fetch_dtl_tick_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.Entrychose;
import java.util.Vector;

public class Bms_sales_back_mde extends CMdeModelAp {
   private String a = "";
   private String b = "";

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_sales_back_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sales_back_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sales_back_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "salesid";
   }

   public String getDetailRelatecolname() {
      return "salesid";
   }

   public String getSaveCommandString() {
      return "Bms_sales_back_mde.销售退货单管理";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("自动记保管账标志", "1"));
      var1.add(new Apinfo("缺省结算方式", "1"));
      var1.add(new Apinfo("缺省发票类型", "1"));
      var1.add(new Apinfo("缺省货品状态", "1"));
      var1.add(new Apinfo("销售模式", "param", "普通销售"));
      var1.add(new Apinfo("是否必须勾原单", "1"));
      var1.add(new Apinfo("禁止确定", "1"));
      var1.add(new Apinfo("禁止回退确定", "1"));
      var1.add(new Apinfo("禁止作废", "1"));
      var1.add(new Apinfo("禁止生成新批号", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (!"由销售单生成".equals(var1)) {
         if ("确定".equals(var1)) {
            var1 = this.getApvalue("禁止确定");
            if ("1".equals(var1)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.a();
               return 0;
            }
         } else if ("回退确定".equals(var1)) {
            var1 = this.getApvalue("禁止回退确定");
            if ("1".equals(var1)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.b();
               return 0;
            }
         } else if ("作废".equals(var1)) {
            var1 = this.getApvalue("禁止作废");
            if ("1".equals(var1)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.c();
               return 0;
            }
         } else if (var1.equals("切换独立单元")) {
            if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.getMasterModel().doRetrieve("1=2");
               }

               return 0;
            }
         } else {
            return super.on_actionPerformed(var1);
         }
      } else {
         int var2;
         if ((var2 = this.getMasterModel().getRow()) < 0) {
            this.warnMessage("警告", "请选择正确的单据!");
         } else if (var2 == this.getMasterModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据!");
         } else if (((Bms_sales_back_master)this.getMasterModel()).on_checkrow(var2, this.getMasterModel().getDBtableModel()) != -1) {
            String var3 = this.getMasterModel().getItemValue(var2, "usestatus");
            if (!"2".equals(var3)) {
               this.warnMessage("警告", "请选择一条临时的单据进行勾兑！");
            } else if ((var3 = this.getMasterModel().getItemValue(var2, "customid")) != null && !"".equals(var3)) {
               String var7;
               if ((var7 = this.getMasterModel().getItemValue(var2, "agentid")).equals("") || var7 == null) {
                  var7 = "-1";
               }

               Bms_fetch_dtl_tick_hov var4 = new Bms_fetch_dtl_tick_hov();
               String var5 = this.getEntryid();
               String var6 = " exists (select storageid from bms_st_def where entryid =  " + var5 + " and  bms_st_def.storageid=bms_fetch_tick_v.storageid ) ";
               var7 = " nvl(allowbackflag,1) = 1 and customid = " + var3 + " and nvl(agentid,-1)=" + var7 + " and satypeid = 1  and entryid=" + var5 + " and nvl(goodsqty, 0) > backQty and" + var6;
               if (var4.showDialog(this.frame, "选择销售细单", "settletypeid", "%", var7) != null) {
                  CTable var8;
                  int[] var9 = (var8 = var4.getTable()).getSelectedRows();
                  DBTableModel var10 = (DBTableModel)var8.getModel();
                  if (var9.length > 0) {
                     ((Bms_sales_back_detail)this.getDetailModel()).gensabackdtl(var9, var10);
                  }
               }
            } else {
               this.warnMessage("警告", "请先录入客户！");
            }
         }

         return 0;
      }
   }

   private void a() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (var1 == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         String var11 = this.getMasterModel().getItemValue(var1, "usestatus");
         if (!"2".equals(var11)) {
            this.warnMessage("警告", "请选择一条临时的销退进行确定！");
         } else {
            ClientRequest var10 = new ClientRequest();
            StringCommand var12 = new StringCommand("Bms_sales_back_mde.销售退货单确定");
            String var3 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
            Vector var4 = new Vector();
            DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("message", "varchar");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("autokeep", "varchar");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("usestatus", "number");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("confirmaname", "varchar");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("confirmdate", "date");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("confirmanid", "number");
            var4.add(var5);
            DBTableModel var15;
            (var15 = new DBTableModel(var4)).appendRow();
            var15.setItemValue(0, "salesid", var3);
            var15.setItemValue(0, "autokeep", this.getApvalue("自动记保管账标志"));
            DataCommand var13;
            (var13 = new DataCommand()).setDbmodel(var15);
            var10.addCommand(var12);
            var10.addCommand(var13);
            var10.addCommand(new StringCommand(this.getEntryid()));
            this.setWaitCursor();
            var11 = null;

            try {
               ServerResponse var14 = SendHelper.sendRequest(var10);
               this.a(var14, "确定", 3, 6);
               this.detailmodel.tableChanged();
               return;
            } catch (Exception var8) {
               this.errorMessage("错误", "确定不成功原因:" + var8.getMessage());
               var8.printStackTrace();
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   private void b() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) < 0) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else if (var1 == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能回退确定,请先保存!");
               return;
            }
         }

         String var12 = this.getMasterModel().getItemValue(var1, "usestatus");
         if (!"1".equals(var12)) {
            this.warnMessage("警告", "销售退货单不是正式状态，不能回退确定！");
         } else {
            String var10;
            if ((var10 = this.getMasterModel().getItemValue(var1, "rgid")) != null && var10.length() > 0) {
               this.warnMessage("警告", "该销售退货单是由\"销退业务处理\"生成，不能回退确定！");
            } else {
               ClientRequest var11 = new ClientRequest();
               StringCommand var13 = new StringCommand("Bms_sales_back_mde.销售退货单回退确定");
               String var3 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
               Vector var4 = new Vector();
               DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("message", "varchar");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("usestatus", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmaname", "varchar");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmdate", "date");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmanid", "number");
               var4.add(var5);
               DBTableModel var16;
               (var16 = new DBTableModel(var4)).appendRow();
               var16.setItemValue(0, "salesid", var3);
               DataCommand var14;
               (var14 = new DataCommand()).setDbmodel(var16);
               var11.addCommand(var13);
               var11.addCommand(var14);
               this.setWaitCursor();
               var12 = null;

               try {
                  ServerResponse var15 = SendHelper.sendRequest(var11);
                  this.a(var15, "回退确定", 2, 5);
                  this.detailmodel.tableChanged();
                  return;
               } catch (Exception var8) {
                  this.errorMessage("错误", "回退确定不成功原因:" + var8.getMessage());
                  var8.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

            }
         }
      }
   }

   private void c() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         int var3;
         int[] var14;
         if ((var3 = (var14 = this.getDetailModel().getTable().getSelectedRows()).length) < 0) {
            this.warnMessage("警告", "请选择单据进行作废!");
         } else if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
            this.warnMessage("警告", "选中行错误,请重新选择!!!");
         } else {
            if (var14[var14.length - 1] == this.getDetailModel().getRowCount()) {
               --var3;
            }

            String var12 = this.getMasterModel().getItemValue(var1, "salesid");
            Vector var4 = new Vector();
            DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("message", "varchar");
            var4.add(var5);
            var5 = new DBColumnDisplayInfo("salesdtlid", "number");
            var4.add(var5);
            DBTableModel var16 = new DBTableModel(var4);

            String var6;
            for(int var17 = 0; var17 < var3; ++var17) {
               if (this.getMasterModel().getdbStatus(var14[var17]) != 0) {
                  this.warnMessage("警告", "第" + (var14[var17] + 1) + "行细单没有保存不能作废,请先保存!");
                  return;
               }

               var6 = this.getDetailModel().getItemValue(var14[var17], "stioflag");
               if ("1".equals(var6)) {
                  this.warnMessage("警告", "第" + (var14[var17] + 1) + "行细单已记保管账,不能作废！");
                  return;
               }

               var6 = this.getDetailModel().getItemValue(var14[var17], "salesdtlid");
               int var7 = var16.getRowCount();
               var16.appendRow();
               var16.setItemValue(var7, "salesid", var12);
               var16.setItemValue(var7, "salesdtlid", var6);
            }

            if (var16.getRowCount() > 0) {
               ClientRequest var18 = new ClientRequest();
               DataCommand var19;
               (var19 = new DataCommand()).setDbmodel(var16);
               var18.addCommand(new StringCommand("Bms_sales_back_mde.销售退货单作废"));
               var18.addCommand(var19);
               this.setWaitCursor();
               var6 = null;

               label168: {
                  try {
                     ServerResponse var20;
                     StringCommand var21;
                     if (!(var21 = (StringCommand)(var20 = SendHelper.sendRequest(var18)).commandAt(0)).getString().startsWith("+OK")) {
                        this.errorMessage("错误", "作废不成功,原因:" + var21.getString());
                     } else {
                        DBTableModel var13 = ((DataCommand)var20.commandAt(1)).getDbmodel();
                        String var15 = "";

                        for(var3 = 0; var3 < var13.getRowCount(); ++var3) {
                           if (!var13.getItemValue(var3, "message").startsWith("+OK")) {
                              var15 = var15 + var13.getItemValue(var3, "salesdtlid") + "、";
                           }
                        }

                        if ("".equals(var15)) {
                           this.infoMessage("提示", "作废成功！");
                        } else {
                           this.infoMessage("提示", "ID为" + var15.substring(0, var15.length() - 1) + "的细单作废失败！");
                        }
                     }
                     break label168;
                  } catch (Exception var10) {
                     var10.printStackTrace();
                     this.errorMessage("错误", "作废不成功,原因:" + var10.getMessage());
                  } finally {
                     this.setDefaultCursor();
                  }

                  return;
               }

               this.getMasterModel().doRequery();
            }
         }
      } else {
         this.warnMessage("警告", "请选择正确的单据进行作废!");
      }
   }

   private void a(ServerResponse var1, String var2, int var3, int var4) {
      String var5;
      if (!(var5 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var5);
      } else {
         DBTableModel var13 = this.getMasterModel().getDBtableModel();
         DBTableModel var12;
         int var6 = (var12 = ((DataCommand)var1.commandAt(1)).getDbmodel()).getColumnCount();

         for(int var7 = 0; var7 < var12.getRowCount(); ++var7) {
            String var8 = var12.getItemValue(var7, "salesid");
            String var9 = var12.getItemValue(var7, "message");

            for(int var10 = 0; var10 < var13.getRowCount(); ++var10) {
               if (var13.getItemValue(var10, "salesid").equals(var8)) {
                  if (!var9.startsWith("+OK")) {
                     var13.getRecordThunk(var10).setSaveresult(1, var9);
                     break;
                  }

                  for(int var14 = var3; var14 <= var4 && var14 < var6; ++var14) {
                     var9 = var12.getColumnDBName(var14);
                     var13.setItemValue(var10, var9, var12.getItemValue(var7, var9));
                  }

                  var13.setdbStatus(var10, 0);
                  var13.getRecordThunk(var10).setSaveresult(0, var2 + "成功");
                  break;
               }
            }
         }

         this.getMasterModel().tableChanged();
      }
   }
}
